Index: issm/trunk-jpl/test/NightlyRun/test543.m
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test543.m	(revision 27318)
+++ issm/trunk-jpl/test/NightlyRun/test543.m	(revision 27334)
@@ -5,6 +5,6 @@
 md=setflowequation(md,'SSA','all');
 md.timestepping.start_time = 0;
-md.timestepping.time_step  = 1;
-md.timestepping.final_time = 10;
+md.timestepping.time_step  = 0.05;
+md.timestepping.final_time = 2;
 
 %Basin separation TF
@@ -52,20 +52,36 @@
 trendlin         = [-0.5,-0.2,0.1;0,0,0];
 trendquad        = [0,0.0,0;0.1,0.1,0.1];
-datebreaks       = [4,7;4,7];
+datebreaks       = [0.5,1.5;0.5,1.5];
 polynomialparams = cat(numparams,intercept,trendlin,trendquad);
+% Monthly effects params %
+numbreaksM       = 1;
+intcpsMp0        = [-0.5,-0.5,0,0,0,0,0.5,0.5,0,0,0,0;
+                    -1.0,-1.0,0,0,0,0,1.0,1.0,0,0,0,0];
+intcpsMp1        = [-0.25,-0.25,0,0,0,0,0.,0.,0,0,0,0;
+                    -0.1,-0.1,0,0,0,0,0.1,0.1,0,0,0,0];
+intcpsM          = cat(3,intcpsMp0,intcpsMp1);
+trendsMp0        = [0,0,0,0,0,0,0.,0.0,0,0,0,0;
+                    0.0,0.0,0,-0.0,0,0,0.0,0.0,0,0,0,0];
+trendsMp1        = [0,-0.12,0,0,0,0,0.,0.0,0,0.0,0,0;
+                    0.0,-0.1,0,-0.0,0,0,0.0,0.0,0,0,0,0];
+trendsM          = cat(3,trendsMp0,trendsMp1);
+datebreaksM      = [1;1];
 
-md.frontalforcings.num_basins           = nb_tf;
-md.frontalforcings.basin_id             = idb_tf;
-md.frontalforcings.num_params           = numparams; %number of parameters in the polynomial
-md.frontalforcings.num_breaks           = numbreaks; %number of breakpoints
-md.frontalforcings.subglacial_discharge = 0.01*ones(md.mesh.numberofvertices,1);
-md.frontalforcings.polynomialparams     = polynomialparams;
-md.frontalforcings.datebreaks           = datebreaks;
-md.frontalforcings.ar_order             = 4;
-md.frontalforcings.ma_order             = 2;
-md.frontalforcings.arma_timestep        = 2; %timestep of the ARMA model [yr]
-md.frontalforcings.arlag_coefs          = [[0.1,-0.1,0.01,-0.01];[0.2,-0.2,0.1,0.0]]; %autoregressive parameters
-md.frontalforcings.malag_coefs          = [[0.1,0.0];[0.0,0.1]]; %moving-average parameters
-
+md.frontalforcings.num_basins              = nb_tf;
+md.frontalforcings.basin_id                = idb_tf;
+md.frontalforcings.num_params              = numparams; %number of parameters in the polynomial
+md.frontalforcings.num_breaks              = numbreaks; %number of breakpoints
+md.frontalforcings.subglacial_discharge    = 0.01*ones(md.mesh.numberofvertices,1);
+md.frontalforcings.polynomialparams        = polynomialparams;
+md.frontalforcings.datebreaks              = datebreaks;
+md.frontalforcings.ar_order                = 4;
+md.frontalforcings.ma_order                = 2;
+md.frontalforcings.arma_timestep           = 2; %timestep of the ARMA model [yr]
+md.frontalforcings.arlag_coefs             = [[0.1,-0.1,0.01,-0.01];[0.2,-0.2,0.1,0.0]]; %autoregressive parameters
+md.frontalforcings.malag_coefs             = [[0.1,0.0];[0.0,0.1]]; %moving-average parameters
+md.frontalforcings.monthlyvals_numbreaks   = numbreaksM;
+md.frontalforcings.monthlyvals_intercepts  = intcpsM;
+md.frontalforcings.monthlyvals_trends      = trendsM;
+md.frontalforcings.monthlyvals_datebreaks  = datebreaksM;
 % Floating Ice Melt parameters
 md.basalforcings.floatingice_melting_rate = 0.1*ones(md.mesh.numberofvertices,1);
@@ -102,5 +118,5 @@
    1e-11,2e-11,2e-11,1e-11,1e-9,1e-10,1e-10,1e-10,...
    2e-11,1e-11,1e-11,9e-11,2e-9,1e-10,1e-10,1e-10,...
-   2e-10,1e-10,1e-10,1e-10,5e-9,1e-10,1e-10,1e-10,...
+   2e-6,1e-6,1e-6,1e-6,5e-6,1e-6,1e-6,1e-6,...
    };
 field_values={...
@@ -113,19 +129,19 @@
    (md.results.TransientSolution(1).CalvingMeltingrate),...
    (md.results.TransientSolution(1).BasalforcingsFloatingiceMeltingRate),...
-   (md.results.TransientSolution(5).Vx),...
-   (md.results.TransientSolution(5).Vy),...
-   (md.results.TransientSolution(5).Vel),...
-   (md.results.TransientSolution(5).Thickness),...
-   (md.results.TransientSolution(5).MaskIceLevelset),...
-   (md.results.TransientSolution(5).CalvingCalvingrate),...
-   (md.results.TransientSolution(5).CalvingMeltingrate),...
-   (md.results.TransientSolution(5).BasalforcingsFloatingiceMeltingRate),...
-	(md.results.TransientSolution(10).Vx),...
-	(md.results.TransientSolution(10).Vy),...
-	(md.results.TransientSolution(10).Vel),...
-	(md.results.TransientSolution(10).Thickness),...
-	(md.results.TransientSolution(10).MaskIceLevelset),...
-	(md.results.TransientSolution(10).CalvingCalvingrate),...
-	(md.results.TransientSolution(10).CalvingMeltingrate),...
-	(md.results.TransientSolution(10).BasalforcingsFloatingiceMeltingRate),...
+   (md.results.TransientSolution(20).Vx),...
+   (md.results.TransientSolution(20).Vy),...
+   (md.results.TransientSolution(20).Vel),...
+   (md.results.TransientSolution(20).Thickness),...
+   (md.results.TransientSolution(20).MaskIceLevelset),...
+   (md.results.TransientSolution(20).CalvingCalvingrate),...
+   (md.results.TransientSolution(20).CalvingMeltingrate),...
+   (md.results.TransientSolution(20).BasalforcingsFloatingiceMeltingRate),...
+	(md.results.TransientSolution(40).Vx),...
+	(md.results.TransientSolution(40).Vy),...
+	(md.results.TransientSolution(40).Vel),...
+	(md.results.TransientSolution(40).Thickness),...
+	(md.results.TransientSolution(40).MaskIceLevelset),...
+	(md.results.TransientSolution(40).CalvingCalvingrate),...
+	(md.results.TransientSolution(40).CalvingMeltingrate),...
+	(md.results.TransientSolution(40).BasalforcingsFloatingiceMeltingRate),...
 	};