Index: issm/trunk/src/m/classes/fourierlove.py
===================================================================
--- issm/trunk/src/m/classes/fourierlove.py	(revision 27035)
+++ issm/trunk/src/m/classes/fourierlove.py	(revision 27347)
@@ -1,6 +1,6 @@
 import numpy as np
 
+from checkfield import checkfield
 from fielddisplay import fielddisplay
-from checkfield import checkfield
 from WriteData import WriteData
 
@@ -43,6 +43,5 @@
         # - Correct display to match MATLAB
         #
-        s = '   Fourier Love class:\n'
-        s += '{}\n'.format(fielddisplay(self, 'nfreq', 'number of frequencies sampled (default: 1, elastic) [Hz]'))
+        s = '{}\n'.format(fielddisplay(self, 'nfreq', 'number of frequencies sampled (default: 1, elastic) [Hz]'))
         s += '{}\n'.format(fielddisplay(self, 'frequencies', 'frequencies sampled (convention defaults to 0 for the elastic case) [Hz]'))
         s += '{}\n'.format(fielddisplay(self, 'sh_nmax', 'maximum spherical harmonic degree (default: 256, .35 deg, or 40 km at equator)'))
@@ -64,15 +63,15 @@
         s += '{}\n'.format(fielddisplay(self, 'forcing_type', 'integer indicating the nature and depth of the forcing for the Love number calculation (default: 11):'))
         s += '{}\n'.format('                                                     1:  Inner core boundary -- Volumic Potential')
-        s += '{}\n'.format('                                                     2:  Inner core boundary --  Pressure')
-        s += '{}\n'.format('                                                     3:  Inner core boundary --  Loading')
-        s += '{}\n'.format('                                                     4:  Inner core boundary --  Tangential traction')
-        s += '{}\n'.format('                                                     5:  Core mantle boundary --  Volumic Potential')
-        s += '{}\n'.format('                                                     6:  Core mantle boundary --  Pressure')
-        s += '{}\n'.format('                                                     7:  Core mantle boundary --  Loading')
-        s += '{}\n'.format('                                                     8:  Core mantle boundary --  Tangential traction')
-        s += '{}\n'.format('                                                     9:  Surface--  Volumic Potential')
-        s += '{}\n'.format('                                                     10: Surface--  Pressure')
-        s += '{}\n'.format('                                                     11: Surface--  Loading')
-        s += '{}\n'.format('                                                     12: Surface--  Tangential traction ')
+        s += '{}\n'.format('                                                     2:  Inner core boundary -- Pressure')
+        s += '{}\n'.format('                                                     3:  Inner core boundary -- Loading')
+        s += '{}\n'.format('                                                     4:  Inner core boundary -- Tangential traction')
+        s += '{}\n'.format('                                                     5:  Core mantle boundary -- Volumic Potential')
+        s += '{}\n'.format('                                                     6:  Core mantle boundary -- Pressure')
+        s += '{}\n'.format('                                                     7:  Core mantle boundary -- Loading')
+        s += '{}\n'.format('                                                     8:  Core mantle boundary -- Tangential traction')
+        s += '{}\n'.format('                                                     9:  Surface -- Volumic Potential')
+        s += '{}\n'.format('                                                     10: Surface -- Pressure')
+        s += '{}\n'.format('                                                     11: Surface -- Loading')
+        s += '{}\n'.format('                                                     12: Surface -- Tangential traction ')
         s += '{}\n'.format(fielddisplay(self, 'inner_core_boundary', 'interface index in materials.radius locating forcing. Only used for forcing_type 1--4 (default: 1)'))
         s += '{}\n'.format(fielddisplay(self, 'core_mantle_boundary', 'interface index in materials.radius locating forcing. Only used for forcing_type 5--8 (default: 2)'))
@@ -87,5 +86,5 @@
         self.sh_nmax = 256 # .35 degree, 40 km at the equator
         self.sh_nmin = 1
-        # Work on matlab script for computing g0 for given Earth's structure
+        # Work on Python script for computing g0 for given Earth's structure
         self.g0 = 9.81 # m/s^2
         self.r0 = 6371 * 1e3 # m
@@ -129,8 +128,9 @@
 
         md = checkfield(md, 'fieldname', 'love.istemporal', 'values', [0, 1])
+
         if md.love.istemporal:
             md = checkfield(md, 'fieldname', 'love.n_temporal_iterations', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
             md = checkfield(md, 'fieldname', 'love.time', 'NaN', 1, 'Inf', 1, 'numel', md.love.nfreq / 2 / md.love.n_temporal_iterations)
-        if md.love.sh_nmin <= 1 and (md.love.forcing_type == 9 or md.love.forcing_type == 5 or md.love.forcing_type == 1):
+        if md.love.sh_nmin <= 1 and (md.love.forcing_type == 1 or md.love.forcing_type == 5 or md.love.forcing_type == 9):
             raise RuntimeError('Degree 1 not supported for forcing type {}. Use sh_min >= 2 for this kind of calculation.'.format(md.love.forcing_type))
 