Index: issm/trunk-jpl/src/m/classes/toolkits.py
===================================================================
--- issm/trunk-jpl/src/m/classes/toolkits.py	(revision 25169)
+++ issm/trunk-jpl/src/m/classes/toolkits.py	(revision 27427)
@@ -8,15 +8,14 @@
 
 class toolkits(object):
-    '''
-    TOOLKITS class definition
+    """TOOLKITS class definition
 
-        Usage:
-            self = toolkits()
-    '''
+    Usage:
+        self = toolkits()
+    """
 
     def __init__(self): #{{{
-        #default toolkits
+        # Default toolkits
         if IssmConfig('_HAVE_PETSC_')[0]:
-            #MUMPS is the default toolkits
+            # MUMPS is the default toolkits
             if IssmConfig('_HAVE_MUMPS_')[0]:
                 self.DefaultAnalysis = mumpsoptions()
@@ -31,8 +30,8 @@
                 raise IOError("ToolkitsFile error: need at least Mumps or Gsl to define issm solver type")
 
-        #Use same solver for Recovery mode
+        # Use same solver for Recovery mode
         self.RecoveryAnalysis = self.DefaultAnalysis
 
-        #The other properties are dynamic
+        # The other properties are dynamic
     #}}}
 
@@ -50,9 +49,9 @@
         #    md.toolkits = addoptions(md.toolkits, 'StressbalanceAnalysis')
 
-        #Create dynamic property if property does not exist yet
+        # Create dynamic property if property does not exist yet
         if not hasattr(self, analysis):
             setattr(self, analysis, None)
 
-        #Add toolkits options to analysis
+        # Add toolkits options to analysis
         if len(args) == 1:
             setattr(self, analysis, args[0])
@@ -62,5 +61,5 @@
 
     def checkconsistency(self, md, solution, analyses): #{{{
-        # TODO
+        # TODO:
         # - Implement something closer to a switch as in 
         # src/m/classes/toolkits.m?
@@ -74,17 +73,14 @@
 
     def ToolkitsFile(self, filename): #{{{
-        '''
-        TOOLKITSFILE - build toolkits file
+        """TOOLKITSFILE - build toolkits file
 
-            Build a Petsc compatible options file, from the toolkits model 
-            field + return options string.
-            This file will also be used when the toolkit used is 'issm' instead 
-            of 'petsc'.s
+        Build a PETSc compatible options file, from the toolkits model field + return options string.
+        This file will also be used when the toolkit used is 'issm' instead of 'petsc'.
 
-            Usage:
-                ToolkitsFile(toolkits, filename)
-        '''
+        Usage:
+            ToolkitsFile(toolkits, filename)
+        """
 
-        #open file for writing
+        # Open file for writing
         try:
             fid = open(filename, 'w')
@@ -92,21 +88,21 @@
             raise IOError("ToolkitsFile error: could not open {}' for writing due to".format(filename), e)
 
-        #write header
+        # Write header
         fid.write("%s%s%s\n" % ('%Toolkits options file: ', filename, ' written from Python toolkits array'))
 
-        #start writing options
+        # Start writing options
         for analysis in list(vars(self).keys()):
             options = getattr(self, analysis)
 
-            #first write analysis:
-            fid.write("\n+{}\n".format(analysis))  #append a + to recognize it's an analysis enum
-            #now, write options
+            # First write analysis
+            fid.write("\n+{}\n".format(analysis))  # Append a + to recognize it's an analysis enum
+            # Now, write options
             for optionname, optionvalue in list(options.items()):
 
                 if not optionvalue:
-                    #this option has only one argument
+                    # This option has only one argument
                     fid.write("-{}\n".format(optionname))
                 else:
-                    #option with value. value can be string or scalar
+                    # Option with value. Value can be string or scalar.
                     if isinstance(optionvalue, (bool, int, float)):
                         fid.write("-{} {}\n".format(optionname, optionvalue))