Index: issm/trunk-jpl/src/m/contrib/buzzi/gravity/vfsa.cpp
===================================================================
--- issm/trunk-jpl/src/m/contrib/buzzi/gravity/vfsa.cpp	(revision 27795)
+++ issm/trunk-jpl/src/m/contrib/buzzi/gravity/vfsa.cpp	(revision 27796)
@@ -818,5 +818,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete threads;
 	delete handles;
Index: issm/trunk-jpl/src/m/contrib/larour/mdanalysis.m
===================================================================
--- issm/trunk-jpl/src/m/contrib/larour/mdanalysis.m	(revision 27795)
+++ issm/trunk-jpl/src/m/contrib/larour/mdanalysis.m	(revision 27796)
@@ -330,5 +330,5 @@
 end
 if counter==-1, 
-	error('cound not find input model name matching base workspace names!');
+	error('could not find input model name matching base workspace names!');
 end
 
Index: issm/trunk-jpl/src/m/mech/basalstress.m
===================================================================
--- issm/trunk-jpl/src/m/mech/basalstress.m	(revision 27795)
+++ issm/trunk-jpl/src/m/mech/basalstress.m	(revision 27796)
@@ -34,5 +34,5 @@
 by = -alpha2.*uby;
 
-%reeeturn magnitude of only one output is requested
+%return magnitude of only one output is requested
 if nargout==1
 	bx = b;
Index: issm/trunk-jpl/src/m/modeldata/InterpFromGrid.cpp
===================================================================
--- issm/trunk-jpl/src/m/modeldata/InterpFromGrid.cpp	(revision 27795)
+++ issm/trunk-jpl/src/m/modeldata/InterpFromGrid.cpp	(revision 27796)
@@ -455,5 +455,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	mxFree(threads);
 	mxFree(handles);
Index: issm/trunk-jpl/src/m/parameterization/parameterize.m
===================================================================
--- issm/trunk-jpl/src/m/parameterization/parameterize.m	(revision 27795)
+++ issm/trunk-jpl/src/m/parameterization/parameterize.m	(revision 27796)
@@ -2,7 +2,7 @@
 %PARAMETERIZE - parameterize a model
 %
-%   from a parameter matlab file, start filling in all the @model fields that were not 
+%   from a parameter MATLAB file, start filling in all the @model fields that were not 
 %   filled in by the mesh.m and mask.m @model methods.
-%   Warning: the parameter file must be able to be run in Matlab
+%   Warning: the parameter file must be able to be run in MATLAB
 %
 %   Usage:
Index: issm/trunk-jpl/src/m/parameterization/parameterize.py
===================================================================
--- issm/trunk-jpl/src/m/parameterization/parameterize.py	(revision 27795)
+++ issm/trunk-jpl/src/m/parameterization/parameterize.py	(revision 27796)
@@ -4,9 +4,9 @@
 
 def parameterize(md, parametername):
-    """PARAMETERIZE - parameterize a model
+    """parameterize - parameterize a model
 
     From a parameter Python file, start filling in all the model fields that 
-    were not filled in by the mesh.py and mask.py model methods. Warning: the 
-    parameter file must be able to be run in Python
+    were not filled in by the mesh.py and mask.py model methods. 
+    Warning: the parameter file must be able to be run in Python
 
     Usage:
@@ -17,16 +17,16 @@
     """
 
-    #some checks
+    # Some checks
     if not os.path.exists(parametername):
         raise IOError("parameterize error message: file '%s' not found!" % parametername)
 
-    #Try and run parameter file.
+    # Try and run parameter file
     exec(compile(open(parametername).read(), parametername, 'exec'))
 
-    #Name and notes
+    # Name and notes
     if not md.miscellaneous.name:
         md.miscellaneous.name = os.path.basename(parametername).split('.')[0]
 
-    md.miscellaneous.notes = "Model created by using parameter file: '%s' on: %s." % (parametername, datetime.datetime.strftime(datetime.datetime.now(), '%c'))
+    md.miscellaneous.notes = 'Model created by using parameter file: \'%s\' on: %s.' % (parametername, datetime.datetime.strftime(datetime.datetime.now(), '%c'))
 
     return md
Index: issm/trunk-jpl/src/wrappers/BamgMesher/BamgMesher.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/BamgMesher/BamgMesher.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/BamgMesher/BamgMesher.cpp	(revision 27796)
@@ -40,5 +40,5 @@
 	WriteData(BAMGMESHOUT,bamgmesh_out);
 
-	/*Free ressources: */
+	/*Free resources: */
 	delete bamgopts;
 	delete bamggeom_in;
Index: issm/trunk-jpl/src/wrappers/BamgMesher/BamgMesher.js
===================================================================
--- issm/trunk-jpl/src/wrappers/BamgMesher/BamgMesher.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/BamgMesher/BamgMesher.js	(revision 27796)
@@ -242,5 +242,5 @@
     var return_array=[bamgmeshout, bamggeomout];
 
-    /*Free ressources: */
+    /*Free resources: */
     Module._free(pVerticesSize_mesh_out);
     Module._free(pVertices_mesh_out);
Index: issm/trunk-jpl/src/wrappers/Chaco/Chaco.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/Chaco/Chaco.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/Chaco/Chaco.cpp	(revision 27796)
@@ -66,5 +66,5 @@
 	WriteData(ASSGN_OUT,assignment,nvtxs);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<short>(assignment); 
 	xDelete<double>(goal);
Index: issm/trunk-jpl/src/wrappers/ContourToMesh/ContourToMesh.js
===================================================================
--- issm/trunk-jpl/src/wrappers/ContourToMesh/ContourToMesh.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/ContourToMesh/ContourToMesh.js	(revision 27796)
@@ -80,5 +80,5 @@
 	/*}}}*/
 
-	/*Free ressources: */
+	/*Free resources: */
 	Module._free(pin_nod); 
 	Module._free(pin_nel); 
Index: issm/trunk-jpl/src/wrappers/DistanceToMaskBoundary/DistanceToMaskBoundary.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/DistanceToMaskBoundary/DistanceToMaskBoundary.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/DistanceToMaskBoundary/DistanceToMaskBoundary.cpp	(revision 27796)
@@ -49,5 +49,5 @@
 	WriteData(DISTANCE,distance,nods);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<double>(x);
 	xDelete<double>(y);
Index: issm/trunk-jpl/src/wrappers/ElementConnectivity/ElementConnectivity.js
===================================================================
--- issm/trunk-jpl/src/wrappers/ElementConnectivity/ElementConnectivity.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/ElementConnectivity/ElementConnectivity.js	(revision 27796)
@@ -38,5 +38,5 @@
 	/*}}}*/
 
-	/*Free ressources: */
+	/*Free resources: */
 	Module._free(pconnectivity); 
 	Module._free(connectivitylinear); 
Index: issm/trunk-jpl/src/wrappers/InterpFromMeshToGrid/InterpFromMeshToGrid.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/InterpFromMeshToGrid/InterpFromMeshToGrid.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/InterpFromMeshToGrid/InterpFromMeshToGrid.cpp	(revision 27796)
@@ -62,5 +62,5 @@
 	WriteData(GRIDDATA,griddata,nlines,ncols);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<int>(index);
 	xDelete<double>(x);
Index: issm/trunk-jpl/src/wrappers/InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.js
===================================================================
--- issm/trunk-jpl/src/wrappers/InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.js	(revision 27796)
@@ -72,5 +72,5 @@
 	/*}}}*/
 
-	/*Free ressources: */
+	/*Free resources: */
 	Module._free(pdata_interp); 
 
Index: issm/trunk-jpl/src/wrappers/IssmConfig/IssmConfig.js
===================================================================
--- issm/trunk-jpl/src/wrappers/IssmConfig/IssmConfig.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/IssmConfig/IssmConfig.js	(revision 27796)
@@ -18,5 +18,5 @@
 	/*}}}*/
 
-	/*Free ressources: */
+	/*Free resources: */
 	Module._free(pvalue); 
 
Index: issm/trunk-jpl/src/wrappers/Kriging/Kriging.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/Kriging/Kriging.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/Kriging/Kriging.cpp	(revision 27796)
@@ -64,5 +64,5 @@
 	if(nlhs==2) WriteData(ERROR,error,M_interp,N_interp);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<double>(x);
 	xDelete<double>(y);
Index: issm/trunk-jpl/src/wrappers/MeshPartition/MeshPartition.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/MeshPartition/MeshPartition.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/MeshPartition/MeshPartition.cpp	(revision 27796)
@@ -71,5 +71,5 @@
 	WriteData(NODEPARTITIONING,node_partitioning,numberofvertices);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(elements);
 	xDelete<int>(elements2d);
Index: issm/trunk-jpl/src/wrappers/NodeConnectivity/NodeConnectivity.js
===================================================================
--- issm/trunk-jpl/src/wrappers/NodeConnectivity/NodeConnectivity.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/NodeConnectivity/NodeConnectivity.js	(revision 27796)
@@ -34,5 +34,5 @@
 	/*}}}*/
 
-	/*Free ressources: */
+	/*Free resources: */
 	Module._free(pconnectivity); 
 	Module._free(connectivitylinear); 
Index: issm/trunk-jpl/src/wrappers/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp	(revision 27796)
@@ -38,5 +38,5 @@
 	WriteData(POOLOUT,pool,nel);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<double>(connectivity);
 	xDelete<double>(pool);
Index: issm/trunk-jpl/src/wrappers/Triangle/Triangle.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/Triangle/Triangle.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/Triangle/Triangle.cpp	(revision 27796)
@@ -50,5 +50,5 @@
 	WriteData(SEGMENTMARKERLIST,segmentmarkerlist,nsegs);
 
-	/*free ressources: */
+	/*free resources: */
 	delete domain;
 	delete rifts;
Index: issm/trunk-jpl/src/wrappers/Triangle/Triangle.js
===================================================================
--- issm/trunk-jpl/src/wrappers/Triangle/Triangle.js	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/Triangle/Triangle.js	(revision 27796)
@@ -66,5 +66,5 @@
 	var return_array=[index,x,y,segments,segmentmarkers];
 
-	/*Free ressources: */
+	/*Free resources: */
 	Module._free(pindex); 
 	Module._free(indexlinear); 
Index: issm/trunk-jpl/src/wrappers/matlab/io/WriteMatlabData.cpp
===================================================================
--- issm/trunk-jpl/src/wrappers/matlab/io/WriteMatlabData.cpp	(revision 27795)
+++ issm/trunk-jpl/src/wrappers/matlab/io/WriteMatlabData.cpp	(revision 27796)
@@ -295,5 +295,5 @@
 		mxSetPr(dataref,tmatrix_ptr);
 
-		/*Free ressources:*/
+		/*Free resources:*/
 		xDelete<double>(matrix_ptr);
 	}